Attribute VB_Name = "Module4"
Public Function Newton(RR As Double, R As Double, X1 As Double, Z1 As Double, Y As Double) As Double



'Dim Y As Double, D As Double, X1 As Double, Z1 As Double, RR As Double, R As Double, Pi As Double
Dim D As Double, Pi As Double

Dim F1, F2 As Double
Dim AA(2, 2) As Double, X(2) As Double, Eps0 As Double, Eps As Double, Iter As Integer, Iter0 As Integer, k As Integer
Dim A As Double, i As Double
Pi = 4 * Atn(1)
Eps0 = 0.000000001
Iter0 = 100

'Initialisation des donnes
'X1 = 20
'Z1 = 5
''RR = 20
'R = 5
'Open "fich.txt" For Output As #1

' Initialisation des solutions
A = 1 'Pi / 4
'D = Sqr(Z1 ^ 2 + (X1 * Cos(A)) ^ 2)
'D = RR
D = 20


'For i = 0 To 2500
'Y = i / 100
Iter = 0
Continue:
Iter = Iter + 1

' Evaluation de l'cart des solutions
F1 = RR * Sin(A) + R * Z1 * Sin(A) / D - Y
F2 = Sqr(Z1 ^ 2 + (X1 * Cos(A)) ^ 2) - D

AA(1, 1) = RR * Cos(A) + R * Z1 * Cos(A) / D
AA(1, 2) = -R * Z1 * Sin(A) / D / D
AA(2, 1) = -X1 * X1 * Cos(A) * Sin(A) / Sqr(Z1 ^ 2 + (X1 * Cos(A)) ^ 2)
AA(2, 2) = -1

X(2) = (F1 / AA(1, 1) - F2 / AA(2, 1)) / (AA(1, 2) / AA(1, 1) - AA(2, 2) / AA(2, 1))
X(1) = (F1 / AA(1, 2) - F2 / AA(2, 2)) / (AA(1, 1) / AA(1, 2) - AA(2, 1) / AA(2, 2))

' Meilleure approximation des solutions
A = A - X(1)
D = D - X(2)


Eps = Sqr(X(1) * X(1) + X(2) * X(2))
k = Int(A / 2 / Pi + 0.5)
A = A - k * Pi * 2

If Iter > Iter0 Then
'MsgBox "Pas de convergence aprs " & Iter & " itrations" & Chr(13) & Chr(13) & "Y=" & Y & "  A=" & A * 180 / Pi & "  D=" & D & "  Eps=" & Eps
GoTo Continue1
End If

If Eps > Eps0 Then GoTo Continue
'MsgBox "A(Y=" & Y & ")=" & A / Pi * 180 & " Degrs" & "  D=" & D & "  Eps=" & Eps & "  Iter=" & Iter
'Write #1, Y, A * 180 / Pi, D

Continue1:
'Next i

'Close
'MsgBox "FIN"
encore:
If A > (Pi / 2) Then
A = Pi - A
GoTo encore
End If

Newton = A
'Close
'MsgBox "FIN"
End Function
